static	char	sccsid[]="%Z% %M% %I% %E% %U%";
/*************************************************/
/*  Program name                                 */
/*       int       col_mn_tr_end_proc            */
/* --------------------------------------------- */
/*  (I/O)                                        */
/*       Out        0   :Normal                  */
/*                 -1   :AbNormal                */
/* --------------------------------------------- */
/*  Function :                                   */
/*     Equote no shori.                          */
/* --------------------------------------------- */
/*************************************************/
#include "colmn.h"

extern CLCOMMON  CLcommon;
extern XHASHB	*ProcIndex;

static int giErrorCount;
static tdtGotoLabel tLabel;

tdtCONSTCT *const_ct;
MCAT2 *mcat2;
char *stack_as_name[20];

/********************************************/
/*											*/
/********************************************/
int cl_is_name(nam,n)
char *nam;
int n;
{
	int ret;
	uchar c;

	if (!nam || n<0) ret = -1;
	else if (n <= 0) ret = 0;
	else {
		ret = 0;
		if (akxqkanjilen2(nam,n) == 1) {
			c = akxcupper(*nam);
			if (c=='_' || (c>='A' && c<='Z') || (c>=0xa6 && c<=0xdd)) ret = 1;
		}
		else ret = 1;
	}
	return ret;
}

/********************************************/
/*											*/
/********************************************/
int get_pos_as_name(pprm,nprm)
parmList **pprm;
int nprm;
{
	int i,ret,pos;
	char *p;
	parmList *prm;

	ret = 0;
	pos = 1;	/* 2023.9.24 */
	for (i=0;i<nprm;i++) {
		if (prm = pprm[i]) {
			if (p=prm->prp) {
				if (!stricmp(p,"AS")) {
					ret = i + 1;
					prm->opt = pos;		/* ret>0̂ƂACLcList.cmd.parl[0]->parAS̈ʒu+1 */
					break;
				}
				pos += prm->prmlen + 1;	/* CLcList.cmd.parl[0]->parɂ́Apprm[i]->prp' 'ŘAĂ */
			}
		}
	}
/*
printf("get_pos_as_name: pos=%d\n",pos);
*/
	return ret;
}
#if 0
/********************************************/
/*											*/
/********************************************/
int get_as_name(pprm,nprm,pnam)
parmList **pprm;
int nprm;
char **pnam;
{
	int i,ret;
	char *nam;
	parmList *prm;

	ret = 0;
	nam = NULL;
	if ((i=get_pos_as_name(pprm,nprm))>0 && i<nprm) {
		if (prm = pprm[i]) {
			nam = prm->prp;
			ret = prm->prmlen;
/*
printf("get_as_name: ret=%d nam=[%s]\n",ret,nam);
*/
		}
	}
	if (pnam) *pnam = nam;
	return ret;
}
#endif
/********************************************/
/*											*/
/********************************************/
static int _chk_as_name_sub(leaf)
Leaf  *leaf;
{
	static char *_NAME_="_chk_as_name_sub";
	int ret,level,cmnd,i,n,pos,len;
	char *p,*nam;
	uchar c;
	cmdInfo *pcmd;

	ret = 0;
	if (leaf) {
		if (!(level = leaf->type)) {
			akxs_mseq_i(mcat2);
			tLabel.cur_leaf = leaf;
		}
		level--;
		pcmd = &(leaf->cmd);
		cmnd = pcmd->cid;
/*
printf("_chk_as_name_sub: level=%d cmnd=[%s] leaf->type=%d\n",level,cl_gets_cmd_name(cmnd),leaf->type);
*/
		if (level >= 0) {
			len = 0;
			if (cmnd==C_LOOP || cmnd==C_FOR || cmnd==C_DO || cmnd==C_SWITCH) {
				nam = pcmd->parl[D_LEAF_LABEL].par;
				len = pcmd->parl[D_LEAF_LABEL].parlen;
			}
			else if (nam=leaf->lf_label) {
				len = strlen(nam);
			}
			else if (leaf->cmd.cid == C_LABEL) {
				nam = leaf->cmd.prmp[0]->prp;
				len = leaf->cmd.prmp[0]->prmlen;
			}
			if (len > 0) {
/*
printf("_chk_as_name_sub: len=%d nam=[%s]\n",len,nam);
*/
#if 0
				if (cl_is_name(nam,len) <= 0) {
					/*_chk_as_name_sub: ubN[%s]słB*/
					ERROROUT3(FORMAT(113),_NAME_,FORMAT(598),nam);
					ret = ECL_SCRIPT_ERROR;
				}
				if (!ret) {
#endif
#if 1	/* 2023.8.12 */
					memset(tLabel.label,0,sizeof(tLabel.label));
					strnzcpy(tLabel.label,nam,MAX_LEN_LABEL);
					if (akxs_mseq_r(mcat2,&tLabel) > 0) {
#else
					if (akxs_seqr_str(stack_as_name,level,nam,0) > 0) {
#endif
						/*_chk_as_name_sub: [%s]ƓÕubN^x܂Bline=%d */
						ERROROUT3(FORMAT(599),_NAME_,nam,tLabel.gl_count);
					/*	ret = ECL_SCRIPT_ERROR;	*/
						clerrdisp(ret,leaf);
						giErrorCount++;
					}
					else {
#if 1	/* 2023.8.12 */
						tLabel.lbl_leaf = leaf;
						tLabel.gl_count = leaf->cmd.rc;
						i = akxs_mseq_set(mcat2,-1,&tLabel);
/*
printf("_chk_as_name_sub: set i=%d\n",i);
*/
#else
						if (!(p = cl_const_ct_malloc(const_ct,len+1))) return ECL_MALLOC_ERROR;
						stack_as_name[level] = p;
						memcpy(p,nam,len+1);
/*
printf("_chk_as_name_sub: level=%d p=[%s]\n",level,p);
*/
#endif
					}
#if 0
				}
#endif
#if 0	/* del 2023.8.15 cl_tree_main()Ɉړ */
				if (!ret) {
					if ((pos=inistr((p=pcmd->parl[0].par),"AS")) >= 3) {
						pos -= 2;
						p[pos] = '\0';
						pcmd->parl[0].parlen = pos;
/*
printf("_chk_as_name_sub: len=%d par[0]=[%s]\n",pos,p);
*/
					}
				}
#endif
			}
		}
		if (!ret && leaf->leftleaf) {
			ret = _chk_as_name_sub(leaf->leftleaf);
		}
 		if (!ret && leaf->rightleaf) {
			ret = _chk_as_name_sub(leaf->rightleaf);
		}
	}
	return ret;
}

/********************************************/
/*											*/
/********************************************/
static int _chk_as_name(leaf)
Leaf  *leaf;
{
	int ret;
#if 1	/* 2023.8.12 */
	giErrorCount = 0;
	memset(&tLabel,0,sizeof(tdtGotoLabel));
	if (mcat2 = akxs_mseq2_new(sizeof(tdtGotoLabel),-16,sizeof(Leaf *)+sizeof(long),NULL,NULL)) {
		ret = _chk_as_name_sub(leaf);
		akxs_mseq_free(mcat2);
		if (giErrorCount) ret = ECL_SCRIPT_ERROR;
	}
#else
	memset(stack_as_name,0,sizeof(stack_as_name));
	const_ct = cl_const_ct_new();
	if (const_ct) {
		ret = _chk_as_name_sub(leaf);
		akxm_cct_free(const_ct);
	}
#endif
	else ret = ECL_MALLOC_ERROR;
	return ret;
}

/********************************************/
/*											*/
/********************************************/
void _set_nodeLevel(leaf,level)
Leaf  *leaf;
int   level;
{
	if (leaf) {
		leaf->type = level;
		if (leaf->leftleaf) {
			_set_nodeLevel(leaf->leftleaf,level+1);
		}
 		if (leaf->rightleaf) {
			_set_nodeLevel(leaf->rightleaf,level);
		}
	}
}

/********************************************/
/*											*/
/********************************************/
int col_mn_tr_file_end(y)
condList *y;
{
	Leaf  *leaf;
	int ret;

	if (y->clstcb->nestLev1) {
		/* %s: dmcoqnb܂͂dmcetmbݒ肳܂łB */
		ERROROUT1(FORMAT(36),"col_mn_tr_file_end");
		return ( ECL_LEX );
	}
/*
printf("col_mn_tr_file_end: y->clstcb->TopStack=%08x\n",y->clstcb->TopStack);
*/
	if (!y->clstcb->TopStack) {
		/* col_mn_tr_file_end: Lȕ܂B */
		ERROROUT(FORMAT(37));
		return ( ECL_LEX );
	}
/*
	if (ProcIndex) akxs_xhash_free(ProcIndex);
	ProcIndex = akxs_xhash_new2(0,10,7,sizeof(Leaf *));
*/
	_set_nodeLevel(leaf=search_top_leaf(y),0);
	ret = _chk_as_name(leaf);
	return ret;
}
